; TIP1074.LSP: HELIX3D.LSP   Draw a Helix in 3D   (c)1995, Paul L. Martin

; The original code of Claude Fleury (HELIX.LSP,
; CADalyst Tip #930, December, 1993) has been
; modified in four places marked ;*.

(defun radi (RADIAN)
   (/ (* 180.0 RADIAN) pi)
)

(defun C:HELIX3D ()
   (setq CMD (getvar "CMDECHO"))
   (setvar "CMDECHO" 0)
   (setq BLIP (getvar "BLIPMODE"))
   (setvar "BLIPMODE" 0)
   ;
   ;Data
   ;----
   (prompt "\nHELIX")
   (setq PITCH (getdist "\nPitch                  = "))
   (setq PITCH2 (getint "\nNumber of pitches <2>  = "))
   (cond ((null PITCH2) (setq PITCH2 2)))
   (setq RAD (getdist "\nRadius                 = "))
   (setq PREC (getint "\nDivisions points <100> = "))
   (cond ((null PREC) (setq PREC 100)))
   ;
   ;Execution
   ;---------
   (setq TOUR 0)
   (setq ANG1 (* 0.5 pi))           ;start angle
   (setq PT0 (getpoint "Start point (Center line) "))
   (setq X0 (car PT0) Y0 (cadr PT0) Z0 (caddr PT0))   ;* add
   (setq ANG2 (/ (* 2.0 pi) PREC))
   (setq DISTY (/ PITCH PREC))
   (command "3dpoly" (list X0 Y0 (+ Z0 RAD)))         ;* mod
   (repeat PITCH2
      (repeat PREC
         (setq TOUR (+ 1 TOUR))
         (setq ANG3 (+ (* ANG2 TOUR) ANG1))
         (setq DISTY2 (* DISTY TOUR))
         (setq DISTX (* (cos ANG3) RAD))
         (setq DISTZ (* (sin ANG3) RAD))              ;* mod
         (setq PTX (list (+ DISTX X0) 
               (+ DISTY2 Y0) 
         (+ DISTZ Z0)))               ;* mod
         (command PTX)
      )
   )
   (command "")
   ;
   ;Rotation
   ;--------
   (setq ANG (getangle PT0 "\nRotation angle <90> = "))
   (cond ((null ANG) (setq ANG (/ pi 2.0))))
   (setq ANG (RADI ANG))
   (setq ANG (- ANG 90.0))
   (setq SS (ssget "L"))
   (command "ROTATE" SS "" PT0 ANG)
   ;
   (setvar "CMDECHO" CMD)
   (setvar "BLIPMODE" BLIP)
   (prin1)
); end helix3d.lsp 

